<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Spheres' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Groupes d'organisations
      </span>
    </div>
    <b-overlay
      v-if="loading"
      id="overlay-background"
      :show="loading"
      :variant="'white'"
      :opacity="0.7"
      :blur="'2px'"
      rounded="sm"
      no-wrap
    >
    </b-overlay>
    <b-container v-else fluid>
      <b-row>
        <b-col
          cols="8"
          class="detail-forms"
        >
          <h1>{{ currentUsergroup.display_name }}</h1>
          <SphereForm
            :sphere="currentUsergroup"
            @save="updateSphere"
          />
        </b-col>
        <b-col
          cols="4"
          class="detail-card"
        >
          <SphereCard
            :sphere="currentUsergroup"
          />
        </b-col>
      </b-row>
      <b-row style="height: auto;">
        <b-col
          cols="11"
          class="users-table"
        >
          <h3 class="line-header">
            <img
              src="@/assets/icons/company.svg"
              alt="Icône oprganisation"
            /> Organisations
          </h3>
          <h5 style="margin-left: 1em;">
            Ajouter une organisation au groupe {{ currentUsergroup.display_name }}
          </h5>
          <p style="margin: 0 0 0 1.2em; font-size: 1em;">
            Saisissez les premiers caractères d'une organisation pour lancer une recherche.
          </p>
          <div class="row" style="margin: 0 0 1em 1em;">
            <SearchOrganisations
              style="width: 40%; margin-right: 1rem;"
              :resetAfter="false"
              placeholder="Rechercher une organisation ..."
              @select="setSelectedOrganisation"
            />
            <b-button
              style="margin-top: 0.5em;"
              variant="success"
              :disabled="!selectedOrganisation"
              @click="addOrganisationToSphere"
            >
              Valider
            </b-button>
          </div>
          <b-overlay
            :show="loadingTable"
            :variant="'white'"
            :opacity="0.9"
            :blur="'2px'"
            rounded="sm"
          >
            <CustomTable
              :fields="childrenFields"
              :items="childrenItems"
              :routeTo="'OrganisationDetail'"
              :sortFunction="GET_USERGROUP_CHILDREN"
              @sorted="setChildrenTableSorted"
              @delete="openRemoveOrgModal"
              @loading="setTableLoader"
            />
            <Pagination
              :nbPages="Math.ceil(currentUsergroupChildrenCount/50)"
              @change-page="changeTablePage"
            />
          </b-overlay>
        </b-col>
      </b-row>
    </b-container>
    <RemoveOrgFromSphere
      :open="removingOrg"
      :organisation="orgToRemove"
      @hide="removingOrg = false"
      @remove="removeOrgFromSphere"
    />
  </div>
</template>

<script>
import SphereForm from '@/components/Forms/SphereForm.vue';
import SphereCard from '@/components/Cards/SphereCard.vue';
import SearchOrganisations from '@/components/SearchOrganisations.vue';
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import RemoveOrgFromSphere from '@/components/Modals/RemoveOrgFromSphere.vue';

import { mapState, mapActions } from 'vuex';

export default {
  name: 'SphereDetail',

  components: {
    SphereForm,
    SphereCard,
    SearchOrganisations,
    CustomTable,
    Pagination,
    RemoveOrgFromSphere
  },

  data() {
    return {
      loading: false,
      loadingTable: false,
      childrenFields: [
        {
          key: 'Nom',
          apiName: 'display_name',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Identifiant',
          apiName: 'codename',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Date de création',
          apiName: 'creation_date',
          sortable: true,
          width: '',
          centered: true
        },
        {
          key: 'Retirer du groupe',
          sortable: false,
          width: '',
          centered: true
        }
      ],
      membersFields: [
        {
          key: 'Nom',
          apiName: 'user__last_name',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Prénom',
          apiName: 'user__first_name',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Identifiant',
          apiName: 'user__username',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Rôle',
          apiName: 'role',
          sortable: true,
          width: '10%',
          centered: false
        },
        {
          key: 'Date d\'inscription',
          apiName: 'date_joined',
          sortable: true,
          width: '13%',
          centered: true
        },
        {
          key: 'Dernière connexion',
          apiName: 'user__last_login',
          sortable: true,
          width: '15%',
          centered: true
        },
        {
          key: 'Statut',
          apiName: 'status',
          sortable: true,
          width: '7%',
          centered: true
        },
        {
          key: 'Admin',
          apiName: 'is_superuser',
          sortable: false,
          width: '7%',
          centered: true
        },
        {
          key: 'Retirer du groupe',
          sortable: false,
          width: '10%',
          centered: true
        }
      ],
      membersTableSorted: {
        direction: null,
        field: null
      },
      childrenTableSorted: {
        direction: null,
        field: null
      },
      removingUser: false,
      userToRemove: null,
      removingOrg: false,
      orgToRemove: null,
      selectedOrganisation: null
    };
  },

  computed: {
    ...mapState('users', ['usersList']),
    ...mapState('usergroups', [
      'currentUsergroup',
      'currentUsergroupMembers',
      'currentUsergroupMembersCount',
      'currentUsergroupChildren',
      'currentUsergroupChildrenCount',
      'usergroupsRoles'
    ]),

    childrenItems() {
      return this.currentUsergroupChildren.map(el => {
        return {
          id: el.id,
          'Nom': el.display_name,
          'Identifiant': el.codename,
          'Date d\'inscription': new Date(el.creation_date).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
        }
      });
    },

    membersItems() {
      return this.currentUsergroupMembers.map(el => {
        return {
          id: el.user.id,
          'Nom': el.user.last_name,
          'Prénom': el.user.first_name,
          'Identifiant':el.user.username,
          'Rôle':
            this.usergroupsRoles.find(item => item.choice === el.role) ? this.usergroupsRoles.find(item => item.choice === el.role).label : '',
          'Date d\'inscription': new Date(el.date_joined).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Dernière connexion': new Date(el.user.last_login).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Statut': [
            {choice: 0, value: 'secondary'},
            {choice: 1, value: 'warning'},
            {choice: 2, value: 'success'}
          ].find(item => item.choice === el.status).value,
          'Admin': el.user.is_superuser ? el.user.is_superuser : false
        }
      });
    }
  },

  created() {
    this.loading = true;
    Promise.all([
      this.GET_USERGROUP_DETAIL(this.$route.params.id),
      this.GET_USERGROUP_MEMBERS({
        id: this.$route.params.id,
        ...this.membersTableSorted
      }),
      this.GET_USERGROUP_CHILDREN({
        id: this.$route.params.id,
        ...this.childrenTableSorted
      }),
    ]).then(() => {
      this.loading = false;
    });
  },

  methods: {
    ...mapActions('usergroups', [
      'GET_USERGROUP_DETAIL',
      'GET_USERGROUP_MEMBERS',
      'GET_USERGROUP_CHILDREN',
      'GET_USERGROUPS_SPHERES_LIST',
      'UPDATE_USERGROUP'
    ]),

    ...mapActions('organisations', [
      'GET_ORGANISATIONS_LIST'
    ]),

    setSelectedOrganisation(e) {
      this.selectedOrganisation = e;
    },

    addOrganisationToSphere() {
      this.loading = true;
      this.UPDATE_USERGROUP({
        id: this.currentUsergroup.id,
        data: {
          ...this.currentUsergroup,
          children: [...this.currentUsergroup.children, this.selectedOrganisation.usergroup.id]
        }
      }).then(() => {
        Promise.all([
          this.GET_USERGROUP_DETAIL(this.$route.params.id),
          this.GET_USERGROUP_CHILDREN({
            id: this.$route.params.id,
            ...this.childrenTableSorted
          })
        ]).then(() => {
          this.loading = false;
        });
      });
    },

    updateSphere(e) {
      this.loading = true;
      this.UPDATE_USERGROUP({
        id: this.currentUsergroup.id,
        data: e
      }).then(() => {
        Promise.all([
          this.GET_USERGROUP_DETAIL(this.$route.params.id),
          this.GET_USERGROUPS_SPHERES_LIST({
            direction: null,
            field: null
          })
        ]).then(() => {
          this.loading = false;
        });
      });
    },

    changeTablePage() {
      this.setTableLoader(true);
      this.GET_USERGROUP_CHILDREN({
        id: this.$route.params.id,
        ...this.childrenTableSorted
      })
        .then(() => {
          this.setTableLoader(false);
        })
        .catch((err) => {
          console.error(err);
          this.setTableLoader(false);
        });
    },

    setTableLoader(e) {
      this.loadingTable = e;
    },

    setMembersTableSorted(e) {
      this.membersTableSorted = e;
    },

    setChildrenTableSorted(e) {
      this.childrenTableSorted = e;
    },

    openRemoveUserModal(e) {
      this.removingUser = true;
      this.userToRemove = e;
    },

    openRemoveOrgModal(e) {
      this.removingOrg = true;
      this.orgToRemove = e;
    },

    removeOrgFromSphere(e) {
      const index = this.currentUsergroupChildren.findIndex(el => el.id === e.id);
      const updatedChildren = this.currentUsergroupChildren.map(el => el.id);
      updatedChildren.splice(index, 1);
      const data = {
        ...this.currentUsergroup,
        children: updatedChildren
      };
      this.loading = true;
      this.UPDATE_USERGROUP({
        id: this.currentUsergroup.id,
        data: data
      }).then(() => {
        Promise.all([
          this.GET_USERGROUP_DETAIL(this.$route.params.id),
          this.GET_USERGROUP_MEMBERS({
            id: this.$route.params.id,
            ...this.membersTableSorted
          }),
          this.GET_USERGROUP_CHILDREN({
            id: this.$route.params.id,
            ...this.childrenTableSorted
          }),
          this.GET_ORGANISATIONS_LIST({
            direction: null,
            field: null
          })
        ])
        .then(() => {
          this.loading = false;
        });
      });
    }
  }
}
</script>

<style lang="less" scoped>

.container-fluid {
  margin: 1em;
  padding-bottom: 3em;
  height: fit-content;
  .row {
    height: fit-content;
  }
}

p {
  width: 100%;
  color: grey;
  font-style: italic;
  font-size: 0.7em;
  margin-bottom: 0.2em;
}

</style>
